from typing import Literal

SQLITE_TYPES = Literal["text", "real", "integer", "blob", "numeric", "boolean", "date", "datetime", "json"]

POSTGRES_TYPES = Literal["integer", "smallint", "bigint", "real", "double precision", "decimal", "numeric", 
                         "smallserial", "serial", "bigserial", "text", "timestamp with time zone", "timestamp", 
                         "date", "time with time zone", "time", "interval", "uuid", "json", "jsonb", "boolean", 
                         "bytea", "oid"]

POSTGIS_TYPES = Literal["integer", "smallint", "bigint", "real", "double precision", "decimal", "numeric", 
                        "smallserial", "serial", "bigserial", "text", "timestamp with time zone", "timestamp", 
                        "date", "time with time zone", "time", "interval", "uuid", "json", "jsonb", "boolean", 
                        "bytea", "oid", "geometry", "point", "linestring", "polygon", "multipoint", "multilinestring", 
                        "multipolygon", "geometry collection", "pointz", "linestringz", "polygonz", "multipointz", 
                        "multilinestringz", "multipolygonz", "pointm", "linestringm", "polygonm", "multipointm", 
                        "multilinestringm", "multipolygonm", "pointzm", "linestringzm", "polygonzm", "multipointzm", 
                        "multilinestringzm", "multipolygonzm", "point geography", "linestring geography", 
                        "polygon geography", "multipoint geography", "multilinestring geography", 
                        "multipolygon geography", "geometry collection geography"]


POSTGRES_TYPE_MAP = {"integer": "integer", 
                     "smallint": "smallint", 
                     "bigint": "bigint", 
                     "real": "real", 
                     "double precision": "double precision", 
                     "decimal": "decimal", 
                     "numeric": "numeric", 
                     "smallserial": "smallserial", 
                     "serial": "serial", 
                     "bigserial": "bigserial", 
                     "text": "text", 
                     "timestamp": "timestamp", 
                     "timestamp with time zone": "timestamp with time zone", 
                     "timestamp without time zone": "timestamp without time zone", 
                     "date": "date", 
                     "time with time zone": "time with time zone", 
                     "time": "time", "interval": "interval",
                     "uuid": "uuid", 
                     "json": "json", 
                     "jsonb": "jsonb",
                     "boolean": "boolean",
                     "geometry": "text", 
                     "point": "text", 
                     "linestring": "text", 
                     "polygon": "text", 
                     "multipoint": "text", 
                     "multilinestring": "text", 
                     "multipolygon": "text", 
                     "geometry collection": "text", 
                     "pointz": "text", 
                     "linestringz": "text", 
                     "polygonz": "text", 
                     "multipointz": "text", 
                     "multilinestringz": "text", 
                     "multipolygonz": "text", 
                     "pointm": "text", 
                     "linestringm": "text", 
                     "polygonm": "text", 
                     "multipointm": "text", 
                     "multilinestringm": "text", 
                     "multipolygonm": "text", 
                     "pointzm": "text", 
                     "linestringzm": "text", 
                     "polygonzm": "text", 
                     "multipointzm": "text", 
                     "multilinestringzm": "text", 
                     "multipolygonzm": "text", 
                     "point geography": "text", 
                     "linestring geography": "text", 
                     "polygon geography": "text", 
                     "multipoint geography": "text", 
                     "multilinestring geography": "text", 
                     "multipolygon geography": "text", 
                     "geometry collection geography": "text", 
                     "TEXT": "text", 
                     "REAL": "real", 
                     "INTEGER": "integer", 
                     "BLOB": "bytea", 
                     "NUMERIC": "numeric", 
                     "BOOLEAN": "boolean", 
                     "DATE": "date", 
                     "DATETIME": "timestamp with time zone", 
                     "datetime": "timestamp with time zone", 
                     "JSON": "json"}




POSTGIS_TYPE_MAP = {"integer": "integer", 
                    "smallint": "smallint", 
                    "bigint": "bigint", 
                    "real": "real", 
                    "double precision": "double precision", 
                    "decimal": "decimal", 
                    "numeric": "numeric", 
                    "smallserial": "smallserial", 
                    "serial": "serial", 
                    "bigserial": "bigserial", 
                    "text": "text", 
                    "timestamp": "timestamp", 
                    "timestamp with time zone": "timestamp with time zone", 
                    "timestamp without time zone": "timestamp without time zone", 
                    "date": "date", 
                    "time with time zone": "time with time zone", 
                    "time": "time", "interval": "interval",
                    "uuid": "uuid", 
                    "json": "json", 
                    "jsonb": "jsonb",
                    "boolean": "boolean",
                    "geometry": "geometry", 
                    "point": "point", 
                    "linestring": "linestring", 
                    "polygon": "polygon", 
                    "multipoint": "multipoint", 
                    "multilinestring": "multilinestring", 
                    "multipolygon": "multipolygon", 
                    "geometry collection": "geometry collection", 
                    "pointz": "pointz", 
                    "linestringz": "linestringz", 
                    "polygonz": "polygonz", 
                    "multipointz": "multipointz", 
                    "multilinestringz": "multilinestringz", 
                    "multipolygonz": "multipolygonz", 
                    "pointm": "pointm", 
                    "linestringm": "linestringm", 
                    "polygonm": "polygonm", 
                    "multipointm": "multipointm", 
                    "multilinestringm": "multilinestringm", 
                    "multipolygonm": "multipolygonm", 
                    "pointzm": "pointzm", 
                    "linestringzm": "linestringzm", 
                    "polygonzm": "polygonzm", 
                    "multipointzm": "multipointzm", 
                    "multilinestringzm": "multilinestringzm", 
                    "multipolygonzm": "multipolygonzm", 
                    "point geography": "point geography", 
                    "linestring geography": "linestring geography", 
                    "polygon geography": "polygon geography", 
                    "multipoint geography": "multipoint geography", 
                    "multilinestring geography": "multilinestring geography", 
                    "multipolygon geography": "multipolygon geography", 
                    "geometry collection geography": "geometry collection geography", 
                    "TEXT": "text", 
                    "REAL": "real", 
                    "INTEGER": "integer", 
                    "BLOB": "bytea", 
                    "NUMERIC": "numeric", 
                    "BOOLEAN": "boolean", 
                    "DATE": "date", 
                    "DATETIME": "timestamp with time zone", 
                    "datetime": "timestamp with time zone", 
                    "JSON": "json"}



SQLITE_TYPE_MAP = {"integer": "integer", 
                   "smallint": "integer", 
                   "bigint": "integer", 
                   "real": "real", 
                   "double precision": "real", 
                   "decimal": "real", 
                   "numeric": "numeric",  
                   "smallserial": "integer", 
                   "serial": "integer", 
                   "bigserial": "integer", 
                   "text": "text", 
                   "timestamp": "datetime", 
                   "timestamp with time zone": "datetime", 
                   "timestamp without time zone": "datetime", 
                   "date": "text", 
                   "time with time zone": "text", 
                   "time": "text", 
                   "boolean": "text",
                   "uuid": "text", 
                   "interval": "text",  
                   "json": "json", 
                   "jsonb": "text", 
                   "geometry": "text", 
                   "point": "text", 
                   "linestring": "text", 
                   "polygon": "text", 
                   "multipoint": "text", 
                   "multilinestring": "text", 
                   "multipolygon": "text", 
                   "geometry collection": "text", 
                   "pointz": "text", 
                   "linestringz": "text", 
                   "polygonz": "text", 
                   "multipointz": "text", 
                   "multilinestringz": "text", 
                   "multipolygonz": "text", 
                   "pointm": "text", 
                   "linestringm": "text", 
                   "polygonm": "text", 
                   "multipointm": "text", 
                   "multilinestringm": "text", 
                   "multipolygonm": "text", 
                   "pointzm": "text", 
                   "linestringzm": "text", 
                   "polygonzm": "text", 
                   "multipointzm": "text", 
                   "multilinestringzm": "text", 
                   "multipolygonzm": "text", 
                   "point geography": "text", 
                   "linestring geography": "text", 
                   "polygon geography": "text", 
                   "multipoint geography": "text", 
                   "multilinestring geography": "text", 
                   "multipolygon geography": "text", 
                   "geometry collection geography": "text", 
                   "TEXT": "text", 
                   "REAL": "real", 
                   "INTEGER": "integer", 
                   "NUMERIC": "numeric", 
                   "BLOB": "blob", 
                   "NUMERIC": "numeric", 
                   "BOOLEAN": "boolean", 
                   "DATE": "date", 
                   "DATETIME": "datetime", 
                   "datetime": "datetime", 
                   "JSON": "json"}
